#ifndef	NULLUSOCK

union cb {
	struct tcb *tcb;
	struct ax25_cb *ax25;
	struct udp_cb *udp;
	struct raw_ip *rip;
	struct raw_nr *rnr;
	struct nr4cb *nr4;
	char *p;
};
union sp {
	struct sockaddr *sa;
	struct sockaddr_in *in;
	struct sockaddr_ax *ax;
	struct sockaddr_nr *nr;
	char *p;
};

/* User sockets */
struct usock {
	struct proc *owner;
	char noblock;
	char type;
#define	NOTUSED		0
#define	TYPE_TCP	1
#define	TYPE_UDP	2
#define	TYPE_AX25I	3
#define	TYPE_AX25UI	4
#define TYPE_RAW	5
#define TYPE_NETROML3	6
#define TYPE_NETROML4	7
	int rdysock;
	union cb cb;
	char *name;
	int namelen;
	char *peername;
	int peernamelen;
	char errcodes[4];	/* Protocol-specific error codes */
};
#define	NULLUSOCK	((struct usock *)0)

extern char *Socktypes[];
extern struct usock *Usock;
extern int Nusock;

#endif /* NULLUSOCK */
